import oscar.cp._
object Queens extends CPModel with App {
  val nQueens = 12 // Number of queens
  val Queens = 0 until nQueens
  // Variables
  val queens = Array.fill(nQueens)(CPIntVar.sparse(0, nQueens - 1))
  // Constraints
  add(allDifferent(queens))
  add(allDifferent(Queens.map(i => queens(i) + i)))
  add(allDifferent(Queens.map(i => queens(i) - i)))
  // Search heuristic
  search(binaryFirstFail(queens))
  onSolution{
    print("Solution potentielle\n")
    println(queens.mkString(" "))
  }
  // Execution
  val stats = start()
  println(stats)



}
